local DUFlocked = true
local playerDebuffsEnabled = true
local enemyBuffsEnabled = true
local friendlyBuffsEnabled = false
local DUFTooltipScale = 0.77
local DUFDebuffTooltipParent = CreateFrame("Frame","DUFDebuffTooltipParent",UIParent)
DUFDebuffTooltipParent:RegisterUnitEvent("UNIT_AURA", "player")
DUFDebuffTooltipParent:RegisterUnitEvent("PLAYER_TARGET_CHANGED")
DUFDebuffTooltipParent:SetMovable(true)
DUFDebuffTooltipParent:SetSize(40, 40)
DUFDebuffTooltipParent:SetFrameStrata("TOOLTIP")
DUFDebuffTooltipParent:SetClampedToScreen(true)
DUFDebuffTooltipParent:RegisterForDrag("LeftButton")
DUFDebuffTooltipParent:SetScript("OnDragStart", DUFDebuffTooltipParent.StartMoving)
DUFDebuffTooltipParent:SetScript("OnDragStop", DUFDebuffTooltipParent.StopMovingOrSizing)
DUFDebuffTooltipParent:SetPoint("BOTTOMRIGHT", UIParent, "CENTER", -130,68)
DUFDebuffTooltipParent:Show()

--statusbar background
local debugtexture = DUFDebuffTooltipParent:CreateTexture(nil, "BACKGROUND")
debugtexture:SetAllPoints(DUFDebuffTooltipParent)
debugtexture:SetTexture("Interface\\Tooltips\\UI-Tooltip-Background")
debugtexture:SetColorTexture(0, 0, 0, 0)

DUFDebuffTooltipParent:SetScript("OnEvent", function(self, event, ...)
    for i=1,10 do
        local aura = UnitAura("player",i, "HARMFUL")
        if aura then
            local tooltip
            if not _G["DUFDebuffTooltip"..i] then
                tooltip = CreateFrame("GameTooltip","DUFDebuffTooltip"..i,UIParent,"GameTooltipTemplate")
            else
                tooltip = _G["DUFDebuffTooltip"..i]
            end
            local prev = UnitAura("player",i-1, "HARMFUL")
            if prev then
                _G["DUFDebuffTooltip"..i]:SetPoint("BOTTOMRIGHT", _G["DUFDebuffTooltip"..i-1], "TOPRIGHT", 0,0)
            else
                _G["DUFDebuffTooltip"..i]:SetPoint("BOTTOMRIGHT", DUFDebuffTooltipParent, "BOTTOMRIGHT", 0,0)
            end
            _G["DUFDebuffTooltip"..i]:ClearLines()
            _G["DUFDebuffTooltip"..i]:SetScale(DUFTooltipScale)
            _G["DUFDebuffTooltip"..i]:SetOwner(UIParent,"ANCHOR_PRESERVE")
            _G["DUFDebuffTooltip"..i]:SetUnitAura("player",i, "HARMFUL")
            _G["DUFDebuffTooltip"..i]:Show()
        else
            if _G["DUFDebuffTooltip"..i] then
                _G["DUFDebuffTooltip"..i]:Hide()
            end
        end
    end
end)

local function DUF_ScanBuffs()
    if not UnitExists("target") then
        for i=1,10 do
            if _G["DUFBuffTooltip"..i] then
                _G["DUFBuffTooltip"..i]:ClearLines()
                _G["DUFBuffTooltip"..i]:Hide()
            end
        end
    end
    if (UnitIsEnemy("player","target")) or (friendlyBuffsEnabled == true) then
        for i=1,10 do
            local aura = UnitAura("target",i, "HELP")
            if aura then
                local tooltip
                if not _G["DUFBuffTooltip"..i] then
                    tooltip = CreateFrame("GameTooltip","DUFBuffTooltip"..i,UIParent,"GameTooltipTemplate")
                else
                    tooltip = _G["DUFBuffTooltip"..i]
                end
                local prev = UnitAura("target",i-1, "HELP")
                if prev then
                    _G["DUFBuffTooltip"..i]:SetPoint("BOTTOMLEFT", _G["DUFBuffTooltip"..i-1], "TOPLEFT", 0,0)
                else
                    _G["DUFBuffTooltip"..i]:SetPoint("BOTTOMLEFT", DUFBuffTooltipParent, "BOTTOMLEFT", 0,0)
                end
                _G["DUFBuffTooltip"..i]:ClearLines()
                _G["DUFBuffTooltip"..i]:SetScale(DUFTooltipScale)
                _G["DUFBuffTooltip"..i]:SetOwner(UIParent,"ANCHOR_PRESERVE")
                _G["DUFBuffTooltip"..i]:SetUnitAura("target",i, "HELP")
                _G["DUFBuffTooltip"..i]:Show()
            else
                if _G["DUFBuffTooltip"..i] then
                    _G["DUFBuffTooltip"..i]:ClearLines()
                    _G["DUFBuffTooltip"..i]:Hide()
                end
            end
        end
    end
end

--Target Buff Info Frames
local DUFBuffTooltipParent = CreateFrame("Frame","DUFBuffTooltipParent",UIParent)
DUFBuffTooltipParent:RegisterUnitEvent("UNIT_AURA", "target")
DUFBuffTooltipParent:RegisterUnitEvent("PLAYER_TARGET_CHANGED")
DUFBuffTooltipParent:SetMovable(true)
DUFBuffTooltipParent:SetSize(40, 40)
DUFBuffTooltipParent:SetFrameStrata("TOOLTIP")
DUFBuffTooltipParent:SetClampedToScreen(true)
DUFBuffTooltipParent:RegisterForDrag("LeftButton")
DUFBuffTooltipParent:SetScript("OnDragStart", DUFBuffTooltipParent.StartMoving)
DUFBuffTooltipParent:SetScript("OnDragStop", DUFBuffTooltipParent.StopMovingOrSizing)
DUFBuffTooltipParent:SetPoint("BOTTOMLEFT", UIParent, "CENTER", 130,68)
DUFBuffTooltipParent:Show()

--statusbar background
local buffdebugtexture = DUFBuffTooltipParent:CreateTexture(nil, "BACKGROUND")
buffdebugtexture:SetAllPoints(DUFBuffTooltipParent)
buffdebugtexture:SetTexture("Interface\\Tooltips\\UI-Tooltip-Background")
buffdebugtexture:SetColorTexture(0, 0, 0, 0)

DUFBuffTooltipParent:SetScript("OnEvent", function(self, event, ...)
    DUF_ScanBuffs()
end)

--Slash Commands
SLASH_DUFLOCK1 = '/dbt'
SlashCmdList['DUFLOCK'] = function(msg, editbox) 
    if (DUFlocked == true) then
        DUFlocked = false
        debugtexture:SetColorTexture(0, 0.75, 1, 0.5)
        buffdebugtexture:SetColorTexture(0, 0.75, 1, 0.5)

        DUFDebuffTooltipParent:EnableMouse(true)
        DUFBuffTooltipParent:EnableMouse(true)
    else
        DUFlocked = true
        debugtexture:SetColorTexture(0, 0, 0, 0)
        buffdebugtexture:SetColorTexture(0, 0, 0, 0)

        DUFDebuffTooltipParent:EnableMouse(false)
        DUFBuffTooltipParent:EnableMouse(false)
    end
end

SLASH_DUFRESET1 = '/dbtreset'
SlashCmdList['DUFRESET'] = function(msg, editbox) 
    DUFlocked = true

    debugtexture:SetColorTexture(0, 0, 0, 0)
    DUFDebuffTooltipParent:EnableMouse(false)
    DUFDebuffTooltipParent:SetMovable(false)
    DUFDebuffTooltipParent:SetPoint("BOTTOMRIGHT", UIParent, "CENTER", -130,68)
    DUFDebuffTooltipParent:SetMovable(true)    
    
    buffdebugtexture:SetColorTexture(0, 0, 0, 0)
    DUFBuffTooltipParent:EnableMouse(false)
    DUFDebuffTooltipParent:SetMovable(false)
    DUFBuffTooltipParent:SetPoint("BOTTOMLEFT", UIParent, "CENTER", 130,68)
    DUFDebuffTooltipParent:SetMovable(true)
end